var icons = {
    SALSAO:    "celery.png",
    CRUSTACEO: "crustaceans.png",
    OVO:       "egg.png",
    PEIXE:     "fish.png",
    GLUTEN:    "gluten.png",
    TREMOCO:   "lupins.png",
    LEITE:     "milk.png",
    NOZ:       "nut.png",
    MOSTARDA:  "mustard.png",
    AMENDOIM:  "peanut.png",
    SESAMO:    "sesame.png",
    MARISCO:   "shellfish.png",
    SOJA:      "soy.png",
    SULFITO:   "sulfites.png"
};

function getFileNameIcon( iconName ) {
    return icons[iconName];  
}

function getPathLocalImage( fileName ) {
    return "src/assets/img/" + fileName;
}

function getLocalIcon( iconName ) {
  var iconFile = getFileNameIcon(iconName);
  return getPathLocalImage( iconFile );
}

function handleJoinedIcons ( iconsString ) {
    var mappedIcons = [];
    if( iconsString && iconsString.length ) {
        var icons = iconsString.split('$$');
        for( var i = 0; i < icons.length; i++) {
            mappedIcons.push({
                NRALERGENICO: icons[i],
                NMALERGENICO: icons[++i],
                ICONE: icons[++i],
                ARMAZENAMENTO: icons[++i]
            });
        }
    }
    return mappedIcons;
}

function iconNeedsInvisible ( icon, typeStorage ) {
    var hideIcon = true
    if( icon && icon.ARMAZENAMENTO == typeStorage ) {
        hideIcon = false
    }
    return hideIcon
}

function isInvalidIcon( icon ){
    
    return icon && params["__format"].value.toUpperCase() == "PDF" ? false : true;
}

function getNameIcons( icons ){
    var names = "";
    for(var i = 0; i < icons.length; i++) {
        names += icons[i].NMALERGENICO;
        if( i != icons.length - 1) {
            names += ", "
        }
    }
    return names;
}

function hideLocalIcon(iconsStr, curIcon) {
    if( iconsStr ) {
        return iconsStr.indexOf('$$'+ curIcon + '$$LOCAL$$') == -1;
    } else {
        return true;
    }
}

function getIcon(icon, typeStorage) {
    var iconToReturn = ""
    if( icon && typeStorage == "LOCAL") {
        iconToReturn = getLocalIcon(icon.ICONE)
    } else if( icon && typeStorage == "FILESERVER" ) {
        iconToReturn = getUrlRemoteImage(icon.ICONE)
    }
    return iconToReturn
}