<?php
namespace Teknisa\PLA\Modules\Requisicao\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use \Setforms2\Shared\ORM\DateTime;
use Zeedhi\Framework\Report\ReportService;

class Pla00601RequisicaoServicoRelatorio extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $birtStrategy;
    protected $environment;
    protected $Pla00600RequisicaoServico;
    protected $util;

    public function __construct($Pla00600RequisicaoServico, ReportService $reportService, $entityManager, $qr2Strategy, $environment, $birtStrategy, $util) {
      $this->Pla00600RequisicaoServico = $Pla00600RequisicaoServico;
      $this->entityManager   = $entityManager;
      $this->qr2Strategy     = $qr2Strategy;
      $this->environment     = $environment;
      $this->birtStrategy    = $birtStrategy;
      parent::__construct($reportService);
      $this->util           = $util;
    }

    protected $reportMapping = array (
      'PLA00600' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
          'NRORG'  => 'P_NRORG'
        )
      ),
      'PLA00601' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
          'NRORG' => 'P_NRORG'
        )
      ),
      'PLA00602' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
          'NRORG' => 'P_NRORG'
        )
      ),
      'PLA00603' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
          'NRCONSPLAN' => 'P_NRCONSPLAN',
          'CDLCLIPENT' => 'P_CDLCLIPENT',
          'NRORG'      => 'P_NRORG'
        )
      ),
      'PLA00604' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' =>'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD'  => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR'    => 'P_CDOPERADOR',
          'NMOPERADOR'    => 'P_NMOPERADOR',
          'CDFILIAL'      => 'P_CDFILIAL',
          'CDSERVFILI'    => 'P_CDSERVFILI',
          'TODOS'         => 'P_TODOS',
          'DTINICIAL'     => 'P_DTINICIAL',
          'DTFINAL'       => 'P_DTFINAL',
          'IDCARD'        => 'P_IDCARD',
          'IDFIXO'        => 'P_IDFIXO',
          'IDPERC'        => 'P_IDPERC',
          'ORDENA'        => 'P_ORDENA',
          'TAMNIV'        => 'P_TAMNIV',
          'NRORG'         => 'P_NRORG'
        )
      ),
      'PLA00605' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD' => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA' => 'P_NRLINHABRANCA',
          'CDOPERADOR' => 'P_CDOPERADOR',
          'NMOPERADOR' => 'P_NMOPERADOR',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'TODOS' => 'P_TODOS',
          'DTINICIAL' => 'P_DTINICIAL',
          'DTFINAL' => 'P_DTFINAL',
          'IDCARD' => 'P_IDCARD',
          'IDFIXO' => 'P_IDFIXO',
          'IDPERC' => 'P_IDPERC',
          'ORDENA' => 'P_ORDENA',
          'TAMNIV' => 'P_TAMNIV',
          'NRORG'  => 'P_NRORG'
        )
      ),
      'PLA00609' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'IDQUEBRAPAGINA'  => 'P_IDQUEBRAPAGINA',
          'IDIMPRIMECARD'   => 'P_IDIMPRIMECARD',
          'NRLINHABRANCA'   => 'P_NRLINHABRANCA',
          'CDOPERADOR'      => 'P_CDOPERADOR',
          'NMOPERADOR'      => 'P_NMOPERADOR',
          'CDFILIAL'        => 'P_CDFILIAL',
          'CDSERVFILI'      => 'P_CDSERVFILI',
          'TODOS'           => 'P_TODOS',
          'DTINICIAL'       => 'P_DTINICIAL',
          'DTFINAL'         => 'P_DTFINAL',
          'IDCARD'          => 'P_IDCARD',
          'IDFIXO'          => 'P_IDFIXO',
          'IDPERC'          => 'P_IDPERC',
          'ORDENA'          => 'P_ORDENA',
          'TAMNIV'          => 'P_TAMNIV',
          'NRORG'           => 'P_NRORG',
          'CDPICTPROD'      => 'P_CDPICTPROD'
        )
      )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();

            $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));

            $row['NRORG'] = $this->environment->getNrOrg();
            
            
            $this->qr2Strategy->setQr2Type($row['QR2TYPE']);

            if ($row['CDSERVFILI'] == "T") {
              $row['CDSERVFILI'] = $this->Pla00600RequisicaoServico->retornaServicos($row) ?? 'X';
              $row['TODOS'] = $row['CDSERVFILI'];
            }

            if($row['__report_name'] == 'PLA00603') {
              $nrListaPontoEntrega = $this->util->criarListaValores($row['CDLCLIPENT']);
              $row['CDLCLIPENT'] = $row['CDLCLIPENT'] == null ? $row['CDTCLIPENT'] : $nrListaPontoEntrega;
              
              if($row['CDTCLIPENT'] == 'T') {
                $row['CDLCLIPENT'] = $this->Pla00600RequisicaoServico->searchDeliveryPoints($row);
                $row['CDTCLIPENT'] = $row['CDLCLIPENT'];
                
              }
              if(!$row['CDLCLIPENT']) {
                $row['CDLCLIPENT'] = 'X';
              }
            }
        } catch (\Exception $e) {

            $response->setError(new Error($e->getMessage(), 1));

        }
    }

}